%%
%% appconstpool.tex
%% $Id: apprule.tex,v 1.9 2003-03-07 10:01:20 baurma Exp $
%%

\section{JNukeInstrRule}

\label{app:instrrule}

A \texttt{JNukeInstrRule} object encapsulated a single instrumentation rule.
A rule consists of a name and two functions \texttt{eval} and \texttt{exec}.
Instrumentation rules are usually added to \texttt{JNukeInstrument} container
objects.

%% ------------------------------------------------------------------

\subsection{Constructor}

\code{
JNukeObj * \\
JNukeInstrRule\_new ( \\
\tab	JNukeMem * mem \\
)
}

\subsubsection{Description}

The constructor is called to obtain a reference to a new object instance.

\subsubsection{Parameters}

\begin{description}
\ttitem{mem}
	A memory manager object of type \texttt{JNukeMem}.
	It is being used to allocate memory for the new object instance.
\end{description}

\subsubsection{Return value}

	A pointer to a new instance of a \texttt{JNukeInstrRule} object.

%% ------------------------------------------------------------------

\subsection{JNukeInstrRule\_setName}

\code{
void \\
JNukeInstrRule\_setName (\\
\tab	JNukeObj * this, \\
\tab	const char *name \\
)
}


\subsubsection{Description}

Set the name of the rule.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a rule object whose name should be set
\ttitem{name}
	The name to be set. The reference must be valid,
	i.e not \texttt{NULL}.
\end{description}

\subsubsection{Return value}

None.



%% ------------------------------------------------------------------

\subsection{JNukeInstrRule\_getName}

\code{
JNukeObj *\\
JNukeInstrRule\_getName (\\
\tab	JNukeObj * this \\
)
}

\subsubsection{Description}

Get rule name.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a rule object whose name should be returned.
\end{description}

\subsubsection{Return value}

Pointer to a string object with the name or \texttt{NULL} 
if the rule has no name.

%% ------------------------------------------------------------------

\subsection{JNukeInstrRule\_setEvalMethod}

\code{
void \\
JNukeInstrRule\_setEvalMethod (\\
\tab	JNukeObj * this, \\
\tab	ir\_evalfunc evalmeth \\
)
}

\subsubsection{Description}

Set location evaluation function connected with this rule.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Pointer to the rule object whose eval method should
	be set.
\ttitem{evalmeth}
	A reference to the eval method. The method must have
	return type \texttt{int}. During instrumentation,
	exactly two arguments of type \texttt{JNukeObj *} will 
	be passed to the method.
\end{description}

\subsubsection{Return value}

None.

%% ------------------------------------------------------------------

\subsection{JNukeInstrRule\_getEvalMethod}

\code{
ir\_evalfunc \\
JNukeInstrRule\_getEvalMethod (\\
\tab	JNukeObj * this \\
)
}

\subsubsection{Description}

Get a reference to the location evaluation function.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to the rule whose location evaluation function
	should be queried.
\end{description}

\subsubsection{Return value}

A pointer to the rule whose location evaluation function or
\texttt{NULL} if there is no eval method associated with
this rule.

%% ------------------------------------------------------------------

\subsection{JNukeInstrRule\_setExecMethod}

\code{
void \\
JNukeInstrRule\_setExecMethod ( \\
\tab	JNukeObj * this, \\
\tab	ir\_execfunc execmeth \\
)
}

\subsubsection{Description}

Set instrumenting function.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to an instrumentation rule object.
\ttitem{execmeth}
	Pointer to the instrumenting function. 
	The function may not return values, i.e., must have
	return type \texttt{void}. During instrumentation,
	exactly one parameter is passed, so it must accept
	a reference of type \texttt{JNukeObj *} with the
	instrumentation context as argument.
\end{description}

\subsubsection{Return value}

None.

%% ------------------------------------------------------------------

\subsection{JNukeInstrRule\_getExecMethod}

\code{
ir\_execfunc \\
JNukeInstrRule\_getExecMethod (\\
\tab	JNukeObj * this \\
)
}

\subsubsection{Description}

Obtain a pointer to the instrumenting function.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to an instrumentation rule object.
\end{description}

\subsubsection{Return value}

A pointer to the instrumenting function.


%% ------------------------------------------------------------------

\subsection{JNukeInstrRule\_eval}

\code{
int \\
JNukeInstrRule\_eval (\\
\tab	JNukeObj * this, \\
\tab	JNukeObj * instr \\
\tab	JNukeObj * data \\
)
}

\subsubsection{Description}

Perform an explicit call to the location evaluation function associated
with the rule.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	The rule whose eval function should be executed.
\ttitem{instr}
	An instrumentation context to be passed to the
	function as first argument.
\ttitem{data}
	Additional data who should be passed to the function
	as second argument. For most rules, a \texttt{NULL}
	value is expected, but the meaning of this parameter
	depends on the function.
\end{description}

\subsubsection{Return value}

This value returns a boolean value with the result of the
function call.


%% ------------------------------------------------------------------

\subsection{JNukeInstrRule\_execute}

\code{
void JNukeInstrRule\_execute (\\
\tab	JNukeObj * this, \\
\tab	JNukeObj * instr \\
)
}

\subsubsection{Description}

Perform an explicit call to the instrumenting function connected
with the rule.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	The rule whose exec function should be executed.
\ttitem{instr}
	An instrumentation context to be passed to the
	function as first and only argument.
\end{description}

\subsubsection{Return value}

None.

%% ------------------------------------------------------------------

